require 'xml/parserns'

class P < XML::ParserNS
  def startElement(n, a)
    p [:START_ELEMENT, n, a, getSpecifiedAttributes]
  end
  def character(data)
    p [:CHARACTER, data]
  end
  def comment(data)
    p [:COMMENT, data]
  end
  def default(data)
    p [:DAFAULT, data]
  end
end

p = P.new(nil, '!')
p.setReturnNSTriplet(true)
p.parse $< do |t, n, a|
  p [t, n, a]
end
